//+------------------------------------------------------------------+
//|                                             sCloseTradeAfter.mq4 |
//|                                       Copyright  2010, hasayama |
//|                                     mailto: mrhasayama@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, hasayama"
#property link      "mailto: mrhasayama@gmail.com"
#property show_inputs

extern datetime	CloseTime		= D'2010.09.17 17:00';
extern bool			AllowInfo		= true;
extern bool			UseLocalTime	= false;
extern int			Slippage			= 5;


int start()
{
	if ( AllowInfo )
	{
		string comm = "server time";
		if ( UseLocalTime ) { comm = "local time"; }
		Comment( "\nsCloseTradeAfter enabled on this chart.\nWill close trade at: ", TimeToStr( CloseTime ), " ", comm, "." );
	}
	
	int ticket = -1, type = -1;
	double lots = 0, price = 0;
	
	datetime CurrentTime = 0;
	
	while ( !IsStopped() )
	{
		if ( UseLocalTime ) { CurrentTime = TimeLocal(); }
		else { CurrentTime = TimeCurrent(); }
		
		if ( CurrentTime < CloseTime ) { Sleep(1000); continue; }
		
		for ( int i = OrdersTotal() - 1; i >= 0; i ++ )
		{
			if ( !OrderSelect( i, SELECT_BY_POS, MODE_TRADES ) ) { Print( "OrderSelect error #", GetLastError() ); continue; }
			if ( OrderSymbol() != Symbol() ) { continue; }
			if ( OrderType() > 1 ) { continue; }
			
			type		= OrderType();
			ticket	= OrderTicket();
			lots		= OrderLots();
			
			break;
		}
		
		if ( ticket < 0 ) { Print( "No trades on symbol ", Symbol() ); break; }
		
		RefreshRates();
		
		if ( type == OP_BUY ) { price = NormalizeDouble( Bid, Digits ); }
		else { price = NormalizeDouble( Ask, Digits ); }
			
		if ( OrderClose( ticket, lots, price, Slippage ) )
		{
			Print( "Trade #", ticket, " closed...ok" );
			break;
		}
		
		Print( "Trade close error #", GetLastError() );		
		Sleep(100);
	}
	
	Comment( "" );
	return(0);
}

